Program

'**********************************************************************************************
' File Type	: CallMaster script file by SpeechSoft, Inc. 12/6/99
' Description	: Get Callers touch-tone input. 
'		  Instruct caller to use * for decimal point input, terminating input with #.
' 
'**********************************************************************************************

' Initialize variable
	InputLen = 5
	TermDigit = "#"
	DIGITS = ""
	TMASK = TermDigit
	NDIGITS = InputLen
	TIMEOUT = 5

' Get caller's touch-tone input.  Instruct caller to use * for decimal point input, terminating input with #.
' Entry can be upto 5 digits.  This includes the # key.  Adjust as required.
	GetDTMF DIGITS TMASK NDIGITS TIMEOUT
	Print "digits entered = "
	PrintNL DIGITS

' Get length of input
	StringLength len DIGITS
	Print "Number of digits entered = "
	PrintNL len

' Validate input length required.  Uncomment and replace module number with error module if required.
	If len <> InputLen Then
	   PrintNL "Number of digits entered is less than maximum"
	   'Return 9999
	Else
	EndIf

' Strip off termination mask digit from input length
    	lenminusone = len - 1

' Initialize count start position and other variables					
    	start = 0
	One = 1
	Zero = 0
	MinusOne = 0 - 1

' Move/Copy DIGITS input to new variable without the #
    	MemMove LastDigit DIGITS lenminusone One
	If LastDigit = TermDigit Then
	   MemMove NewInput DIGITS start lenminusone
	Else
	   MemMove NewInput DIGITS start len
	EndIf

	Print "NewInput entered = "
	PrintNL NewInput

	StringLength newlen NewInput
	Print "Number of digits for NewInput = "
	PrintNL newlen


' Use the FindString command to get position of the decimal point.  
' Remember Pos value starts from 0 so add 1 to get value.
' If caller entered 98*7 then Pos = 2 returned from FindString
	Source = NewInput
	Token = "*"
	
	FindString Source Token Pos

' If token (*) not found then Pos returned = -1, error. Replace module number with error module.
	If Pos = MinusOne Then
	   PrintNL "Decimal key not entered"
	   DecimalDigits = newlen
	   DecimalPos = newlen
	   'Return 9999
	Else
	  DecimalDigits = Pos
	  DecimalPos = DecimalDigits + 1
	EndIf


	Print "DecimalPos entered in position "
	PrintNL DecimalPos


' Use the MemMove command to create the integer and decimal parts of the entry
' Remember MemMove starting position is also from 0 

' Get Integer part of the input
	StartingPos = 0
	NumDigits = DecimalDigits
	If DecimalDigits = 0 Then
	   IntegerPart = ""
	Else
	   MemMove IntegerPart Source StartingPos NumDigits
	EndIf
	Print "IntegerPart entered = "
	PrintNL IntegerPart

' Get Decimal part of the input
	StartingPos = DecimalPos
	NumDigits = newlen - DecimalPos
	'If LastDigit = TermDigit Then
	'   NumDigits = lenminusone - DecimalPos
	'Else
	'   NumDigits = len - DecimalPos
	'EndIf

	MemMove DecimalPart Source StartingPos NumDigits
	Print "DecimalPart entered = "
	PrintNL DecimalPart

' Concatenate IntegerPart and DecimalPart variables for DecimalInput
	DecimalVar = "."
	DecimalInput = IntegerPart & DecimalVar
	DecimalInput = DecimalInput & DecimalPart

	Print "DecimalInput = "
	PrintNL DecimalInput


EndProgram
